import _JSXStyle2 from 'styled-jsx/style';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Fragment, createRef } from 'react';
import PropTypes from 'prop-types';
import Color from 'color';

import Calendar from 'react-feather/dist/icons/calendar.js';
import Clock from 'react-feather/dist/icons/clock.js';
import MapPin from 'react-feather/dist/icons/map-pin.js';
import User from 'react-feather/dist/icons/user.js';
import Users from 'react-feather/dist/icons/users.js';

import CalendarEvent from './CalendarEvent.js';
import AddToCalendar from './AddToCalendar.js';
import EventLocation from './EventLocation.js';

import { BREAKPOINTS, OPACITIES, COLORS } from '../constants.js';
import { rgbaOverRgb } from '../utils.js';

var ActiveEvent = function (_CalendarEvent) {
	_inherits(ActiveEvent, _CalendarEvent);

	function ActiveEvent(props) {
		_classCallCheck(this, ActiveEvent);

		var _this = _possibleConstructorReturn(this, (ActiveEvent.__proto__ || Object.getPrototypeOf(ActiveEvent)).call(this, props));

		_this.state = {
			expanded: false
		};

		_this.getEventDate = _this.getEventDate.bind(_this);
		_this.handleOutsideClick = _this.handleOutsideClick.bind(_this);
		_this.handleClick = _this.handleClick.bind(_this);
		_this.addLinkTargets = _this.addLinkTargets.bind(_this);

		_this.descriptionRef = createRef();
		return _this;
	}

	_createClass(ActiveEvent, [{
		key: 'getEventDate',
		value: function getEventDate() {
			var event = this.props.event;

			if (!event.end) {
				event.end = event.start;
			}

			var sameDay = event.start.isSame(event.end, 'day');
			var sameDayAllDay = event.allDay && event.start.isSame(event.end.clone().subtract(1, 'day'));
			if (sameDay || sameDayAllDay) {
				return event.start.format('ll');
			} else {
				var startDate = void 0,
				    endDate = void 0;
				if (event.start.isSame(event.end, 'year')) {
					startDate = event.start.format('MMM D');
					endDate = event.end.format('ll');
				} else {
					var dateFormat = 'll';
					startDate = event.start.format(dateFormat);
					endDate = event.end.format(dateFormat);
				}

				return React.createElement(
					'span',
					null,
					React.createElement(
						'time',
						{ className: 'start-date',
							dateTime: event.start.toISOString()
						},
						startDate
					),
					React.createElement(
						'span',
						null,
						' \u2013 '
					),
					React.createElement(
						'time',
						{ className: 'end-date',
							dateTime: event.end.toISOString()
						},
						endDate
					)
				);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    event = _props.event,
			    showFooter = _props.showFooter;


			var style = void 0;
			if (!this.state.expanded) {
				var rect = this.props.originalElement ? this.props.originalElement.getBoundingClientRect() : {
					top: 1,
					right: 1,
					bottom: 1,
					left: 1,
					width: 0,
					height: 0
				};

				var left = rect.left - 1;
				var top = rect.top - 1;

				var backgroundColor = rgbaOverRgb(Color(event.color).alpha(0.3).array());
				var borderColor = event.color;

				style = {
					width: rect.width * 2,
					height: rect.height * 2,
					transform: 'translate(calc(' + left + 'px - 25%), calc(' + top + 'px - 25%)) scale(0.5)',
					backgroundColor: backgroundColor,
					border: '2px solid ' + borderColor
				};
			}

			var eventTime = this.getEventTime();
			var eventDate = this.getEventDate();
			var className = this.getClassName();
			className += ' active-event';
			if (this.state.expanded) className += ' expanded';

			var headerStyle = void 0;
			if (this.state.expanded) {
				headerStyle = {
					borderBottom: '5px solid ' + event.color
				};
			}

			var hasPresenters = event.presenters && event.presenters.length > 0;

			return React.createElement(
				'div',
				{ key: 'active-event', style: style,
					ref: function ref(div) {
						return _this2.container = div;
					}, className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + (className || '')
				},
				React.createElement(
					'header',
					{ style: headerStyle, ref: function ref(header) {
							return _this2.header = header;
						}, className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]])
					},
					React.createElement(
						'span',
						{
							className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-date-time'
						},
						React.createElement(
							'span',
							{
								className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-date'
							},
							React.createElement(Calendar, null),
							eventDate
						),
						React.createElement(
							'span',
							{
								className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-time'
							},
							React.createElement(Clock, null),
							eventTime
						)
					),
					React.createElement(
						'span',
						{
							className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-title'
						},
						React.createElement(
							'span',
							{
								className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-calendar'
							},
							event.calendar.calname
						),
						event.title
					),
					React.createElement(
						'button',
						{ type: 'button', onClick: this.handleClick,
							title: 'Close active event', className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'close'
						},
						'\xD7'
					)
				),
				(event.location || hasPresenters) && React.createElement(
					'div',
					{
						className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-meta'
					},
					event.location && React.createElement(
						'div',
						{
							className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-meta-pair'
						},
						React.createElement(
							'span',
							{
								className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-meta-label'
							},
							React.createElement(MapPin, null),
							'Location'
						),
						React.createElement(
							'span',
							{
								className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-meta-value event-location'
							},
							React.createElement(EventLocation, { location: event.location })
						)
					),
					hasPresenters && React.createElement(
						'div',
						{
							className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-meta-pair'
						},
						React.createElement(
							'span',
							{
								className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-meta-label'
							},
							event.presenters.length === 1 ? React.createElement(
								Fragment,
								null,
								React.createElement(User, null),
								'Presenter'
							) : React.createElement(
								Fragment,
								null,
								React.createElement(Users, null),
								'Presenters'
							)
						),
						React.createElement(
							'ul',
							{
								className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-meta-value event-presenters'
							},
							event.presenters.map(function (presenter) {
								return React.createElement(
									'li',
									{ key: presenter.name, className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]])
									},
									presenter.name
								);
							})
						)
					)
				),
				event.description && React.createElement('div', {
					ref: this.descriptionRef,
					dangerouslySetInnerHTML: this.markupDescription(event.description),
					className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]]) + ' ' + 'event-desc'
				}),
				showFooter && React.createElement(
					'footer',
					{
						className: _JSXStyle.dynamic([['4112202273', [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]]])
					},
					React.createElement(AddToCalendar, { event: event })
				),
				React.createElement(
					_JSXStyle,
					{
						id: '4112202273',
						dynamic: [OPACITIES.TEXT.PRIMARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.DISABLED, OPACITIES.TEXT.SECONDARY, COLORS.SHADOW, COLORS.SHADOW, COLORS.BACKGROUND, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.SECONDARY, OPACITIES.TEXT.PRIMARY, BREAKPOINTS.SMALL_DESKTOP]
					},
					['.active-event.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;font-family:\'Noto Sans\',sans-serif;color:rgba(0,0,0,' + OPACITIES.TEXT.PRIMARY + ');padding:0.5em;margin:1px;cursor:pointer;box-sizing:border-box;position:fixed;left:0;top:0;width:90vw;height:90vh;font-size:1.5em;overflow:hidden;z-index:100;cursor:auto;visibility:hidden;}', 'header.__jsx-style-dynamic-selector,footer.__jsx-style-dynamic-selector{-webkit-box-flex:0;-webkit-flex-grow:0;-ms-flex-positive:0;flex-grow:0;background-color:transparent;}', '.event-calendar.__jsx-style-dynamic-selector{display:none;font-size:0.7em;color:rgba(0,0,0,' + OPACITIES.TEXT.SECONDARY + ');}', '.event-date-time.__jsx-style-dynamic-selector{margin:0;text-align:center;}', '.event-date.__jsx-style-dynamic-selector{display:none;text-transform:none;}', '.start-date.__jsx-style-dynamic-selector,.end-date.__jsx-style-dynamic-selector{white-space:nowrap;}', '.event-time.__jsx-style-dynamic-selector{margin:0;text-transform:uppercase;}', '.event-title.__jsx-style-dynamic-selector{word-wrap:break-word;max-width:80%;}', '.event-meta.__jsx-style-dynamic-selector{display:none;}', '.event-location.__jsx-style-dynamic-selector{text-align:left;color:rgba(0,0,0,' + OPACITIES.TEXT.SECONDARY + ');}', '.event-desc.__jsx-style-dynamic-selector{-webkit-box-flex:1;-webkit-flex-grow:1;-ms-flex-positive:1;flex-grow:1;-webkit-flex-shrink:1;-ms-flex-negative:1;flex-shrink:1;margin:0;font-size:0.75em;white-space:pre-wrap;word-break:break-word;}', '.event.all-day.__jsx-style-dynamic-selector .event-time.__jsx-style-dynamic-selector{text-align:center;background:#bfbfbf;border-radius:2px;padding:0.15em 0.5em;}', 'header.__jsx-style-dynamic-selector .close.__jsx-style-dynamic-selector{position:absolute;right:0;top:0;cursor:pointer;font-size:1em;background:none;border:none;outline:none;color:rgba(0,0,0,' + OPACITIES.TEXT.DISABLED + ');padding:0.1em;margin:0.1em;line-height:0.65;}', 'header.__jsx-style-dynamic-selector .close.__jsx-style-dynamic-selector:hover{color:rgba(0,0,0,' + OPACITIES.TEXT.SECONDARY + ');}', '.active-event.expanded.__jsx-style-dynamic-selector{font-size:1.5em;background-color:#fdfdfd;border:1px solid grey;padding:0;-webkit-transform:translate(50vw,50vh) translate(-50%,-50%);-ms-transform:translate(50vw,50vh) translate(-50%,-50%);transform:translate(50vw,50vh) translate(-50%,-50%);box-shadow:0 0 20px 0 ' + COLORS.SHADOW + ';visibility:visible;}', '.expanded.__jsx-style-dynamic-selector header.__jsx-style-dynamic-selector,.expanded.__jsx-style-dynamic-selector footer.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-flex-wrap:wrap;-ms-flex-wrap:wrap;flex-wrap:wrap;box-shadow:0 0 5px 0 ' + COLORS.SHADOW + ';background-color:' + COLORS.BACKGROUND + ';overflow:auto;}', '.expanded.__jsx-style-dynamic-selector header.__jsx-style-dynamic-selector{-webkit-flex-shrink:0;-ms-flex-negative:0;flex-shrink:0;padding:0.5em;}', '.expanded.__jsx-style-dynamic-selector footer.__jsx-style-dynamic-selector{-webkit-box-pack:space-around;-webkit-justify-content:space-around;-ms-flex-pack:space-around;justify-content:space-around;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;text-align:center;}', '.expanded.__jsx-style-dynamic-selector header.__jsx-style-dynamic-selector svg,.expanded.__jsx-style-dynamic-selector .event-meta.__jsx-style-dynamic-selector svg{color:rgba(0,0,0,' + OPACITIES.TEXT.SECONDARY + ');height:1em;width:1em;vertical-align:baseline;margin-right:0.25em;overflow:visible;}', '.expanded.__jsx-style-dynamic-selector .event-title.__jsx-style-dynamic-selector,.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector{margin:0.25em;}', '.expanded.__jsx-style-dynamic-selector .event-title.__jsx-style-dynamic-selector{-webkit-order:1;-ms-flex-order:1;order:1;-webkit-box-flex:1;-webkit-flex-grow:1;-ms-flex-positive:1;flex-grow:1;max-width:100%;}', '.expanded.__jsx-style-dynamic-selector .event-calendar.__jsx-style-dynamic-selector{display:block;}', '.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector{-webkit-order:2;-ms-flex-order:2;order:2;font-size:0.9em;}', '.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector svg{vertical-align:middle;}', '.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector svg{margin-right:0.5em;}', '.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector .event-date.__jsx-style-dynamic-selector,.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector .event-time.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;}', '.expanded.__jsx-style-dynamic-selector .event-date.__jsx-style-dynamic-selector,.expanded.__jsx-style-dynamic-selector .event-time.__jsx-style-dynamic-selector{display:block;margin:0.1em 0.25em;white-space:nowrap;}', '.expanded.__jsx-style-dynamic-selector .event-meta.__jsx-style-dynamic-selector{display:block;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-flex-wrap:wrap;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-align-items:space-around;-webkit-box-align:space-around;-ms-flex-align:space-around;align-items:space-around;background-color:#fafafa;border-bottom:1px solid #ccc;font-size:0.75em;}', '.expanded.__jsx-style-dynamic-selector .event-meta-pair.__jsx-style-dynamic-selector{-webkit-flex:1 1;-ms-flex:1 1;flex:1 1;padding:0.75em;border:1px solid #ccc;}', '.expanded.__jsx-style-dynamic-selector .event-meta-pair.__jsx-style-dynamic-selector .event-meta-label.__jsx-style-dynamic-selector{color:rgba(0,0,0,' + OPACITIES.TEXT.SECONDARY + ');white-space:nowrap;}', '.expanded.__jsx-style-dynamic-selector .event-meta-pair.__jsx-style-dynamic-selector .event-meta-value.__jsx-style-dynamic-selector{color:rgba(0,0,0,' + OPACITIES.TEXT.PRIMARY + ');}', '.expanded.__jsx-style-dynamic-selector .event-desc.__jsx-style-dynamic-selector{padding:1em 2em 2em;overflow-y:auto;}', '.expanded.__jsx-style-dynamic-selector .event-location.__jsx-style-dynamic-selector{display:block;}', '.expanded.__jsx-style-dynamic-selector .event-presenters.__jsx-style-dynamic-selector{display:block;padding:0;margin:0;}', '.expanded.__jsx-style-dynamic-selector .event-presenters.__jsx-style-dynamic-selector li.__jsx-style-dynamic-selector{display:inline;}', '.expanded.__jsx-style-dynamic-selector .event-presenters.__jsx-style-dynamic-selector li.__jsx-style-dynamic-selector:not(:last-child)::after{content:\', \';}', '@media (min-width:' + BREAKPOINTS.SMALL_DESKTOP + 'px){.active-event.__jsx-style-dynamic-selector{-webkit-transition-duration:0.15s;transition-duration:0.15s;-webkit-transition-property:left,top,width,height,-webkit-transform,background-color,border;-webkit-transition-property:left,top,width,height,transform,background-color,border;transition-property:left,top,width,height,transform,background-color,border;max-width:90vw;max-height:90vh;width:auto;height:auto;visibility:visible;}header.__jsx-style-dynamic-selector,footer.__jsx-style-dynamic-selector{-webkit-transition-duration:0.15s;transition-duration:0.15s;-webkit-transition-property:background-color,border;transition-property:background-color,border;}.active-event.expanded.__jsx-style-dynamic-selector{font-size:2em;}.event-date-time.__jsx-style-dynamic-selector{text-align:right;}.expanded.__jsx-style-dynamic-selector header.__jsx-style-dynamic-selector{-webkit-box-pack:justify;-webkit-justify-content:space-between;-ms-flex-pack:justify;justify-content:space-between;-webkit-flex-wrap:nowrap;-ms-flex-wrap:nowrap;flex-wrap:nowrap;text-align:left;}.expanded.__jsx-style-dynamic-selector .event-title.__jsx-style-dynamic-selector{margin-right:1em;font-size:1.25em;}.expanded.__jsx-style-dynamic-selector .event-meta.__jsx-style-dynamic-selector{font-size:0.6em;}.expanded.__jsx-style-dynamic-selector .event-meta-pair.__jsx-style-dynamic-selector{padding:0.75em 1em;}.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector{-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;-webkit-box-pack:end;-webkit-justify-content:flex-end;-ms-flex-pack:end;justify-content:flex-end;}.expanded.__jsx-style-dynamic-selector .event-date-time.__jsx-style-dynamic-selector{margin-left:1em;}}']
				)
			);
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this3 = this;

			window.requestAnimationFrame(function () {
				window.requestAnimationFrame(function () {
					_this3.setState({ expanded: true });

					if ('parentIFrame' in window) {
						window.parentIFrame.getPageInfo(function (parentPage) {
							var middleOfParentViewport = parentPage.scrollTop + parentPage.clientHeight / 2 - parentPage.offsetTop;

							var y = middleOfParentViewport > parentPage.clientHeight / 2 ? middleOfParentViewport < window.innerHeight - parentPage.clientHeight / 2 ? middleOfParentViewport + 'px' : '100vh - 50% - 10px' : '50% + 10px';

							var containerMaxHeight = parentPage.clientHeight * 0.9 - 50;
							_this3.container.style.maxHeight = containerMaxHeight + 'px';
							_this3.container.style.transform = 'translate(calc(50vw - 50%), calc(' + y + ' - 50%))';
						});
					}
					document.addEventListener('click', _this3.handleOutsideClick);
				});
			});
			this.addLinkTargets();
		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate() {
			this.addLinkTargets();
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			document.removeEventListener('click', this.handleOutsideClick);
		}
	}, {
		key: 'handleClick',
		value: function handleClick() {
			var _this4 = this;

			window.requestAnimationFrame(function () {
				_this4.setState({ expanded: false }, function () {
					if ('parentIFrame' in window) {
						window.parentIFrame.getPageInfo(false);
					}

					var timeout = window.innerWidth >= BREAKPOINTS.SMALL_DESKTOP ? 140 : 10;

					window.setTimeout(_this4.props.onClose, timeout);
				});
			});
		}
	}, {
		key: 'handleOutsideClick',
		value: function handleOutsideClick(event) {
			var _this5 = this;

			if (event.defaultPrevented) return;

			window.requestAnimationFrame(function () {
				var rect = _this5.container.getBoundingClientRect();
				if (event.clientX < rect.left || event.clientX > rect.right || event.clientY < rect.top || event.clientY > rect.bottom) _this5.handleClick();
			});
		}
	}, {
		key: 'addLinkTargets',
		value: function addLinkTargets() {
			var container = this.descriptionRef.current;

			if (container) {
				var anchors = container.querySelectorAll('a');
				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = anchors[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var anchor = _step.value;

						if (!anchor.target) {
							anchor.target = '_blank';
						}

						if (!anchor.rel) {
							anchor.rel = 'noopener noreferrer';
						}
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}
			}
		}
	}]);

	return ActiveEvent;
}(CalendarEvent);

export default ActiveEvent;


ActiveEvent.propTypes = {
	event: PropTypes.object.isRequired,
	originalElement: PropTypes.object,
	onClose: PropTypes.func,
	showFooter: PropTypes.bool
};

ActiveEvent.defaultProps = {
	showFooter: false
};