import _JSXStyle2 from 'styled-jsx/style';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Clipboard from 'clipboard';
import Color from 'color';

import { COLORS, OPACITIES } from '../constants.js';

var buttonHoverBackgroundColor = new Color(COLORS.PRIMARY).alpha(OPACITIES.SECONDARY);
var secondaryText = new Color(COLORS.TEXT).alpha(OPACITIES.TEXT.SECONDARY);

var Subscription = function (_Component) {
	_inherits(Subscription, _Component);

	function Subscription(props) {
		_classCallCheck(this, Subscription);

		var _this = _possibleConstructorReturn(this, (Subscription.__proto__ || Object.getPrototypeOf(Subscription)).call(this, props));

		_this.state = {
			showSub: false,
			copyButtonHovered: false,
			showUrl: false,
			copied: false
		};

		_this.handleShowSub = _this.handleShowSub.bind(_this);
		_this.handleHideSub = _this.handleHideSub.bind(_this);
		_this.toggleShowUrl = _this.toggleShowUrl.bind(_this);
		_this.handleCopyButtonMouseDown = _this.handleCopyButtonMouseDown.bind(_this);
		_this.handleCopyButtonMouseUp = _this.handleCopyButtonMouseUp.bind(_this);
		return _this;
	}

	_createClass(Subscription, [{
		key: 'UNSAFE_componentWillUpdate',
		value: function UNSAFE_componentWillUpdate(nextProps, nextState) {
			if (this.state.showSub && !nextState.showSub || this.state.showUrl && !nextState.showUrl) this.clipboard.destroy();
		}
	}, {
		key: 'render',
		value: function render() {
			var url = this.props.url;


			var dirs = url.split('?')[0].split('/');
			var filename = dirs[dirs.length - 1];
			var webcalUrl = 'webcal://' + url.substring(url.indexOf('://') + 3);

			return React.createElement(
				'div',
				{
					className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'subscription-component'
				},
				this.state.showSub ? React.createElement(
					'div',
					{
						className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]])
					},
					React.createElement(
						'div',
						{
							className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'sub-controls'
						},
						React.createElement(
							'a',
							{ id: 'webcal-button',
								href: webcalUrl, className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'button outline'
							},
							'Subscribe with Outlook'
						),
						this.state.showUrl ? React.createElement(
							'section',
							{
								className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'copy-with-url'
							},
							React.createElement('input', { type: 'text', id: 'sub-url',
								value: url, readOnly: true, className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]])
							}),
							React.createElement(
								'button',
								{ id: 'copy-button',
									'data-clipboard-target': '#sub-url',
									title: 'Long press to hide url',
									onMouseDown: this.handleCopyButtonMouseDown,
									onMouseUp: this.handleCopyButtonMouseUp, className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'button'
								},
								'Copy subscription address'
							)
						) : React.createElement(
							'button',
							{ id: 'copy-button',
								'data-clipboard-text': url,
								title: 'Long press to show url',
								onMouseDown: this.handleCopyButtonMouseDown,
								onMouseUp: this.handleCopyButtonMouseUp, className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'button outline'
							},
							'Copy subscription address'
						),
						React.createElement(
							'a',
							{ id: 'download-button',
								href: url, target: '_blank', rel: 'noopener noreferrer',
								download: filename, className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'button outline'
							},
							'Download ICal/.ics file'
						)
					),
					React.createElement(
						'div',
						{
							className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'text-center'
						},
						React.createElement(
							'a',
							{ href: '#', id: 'hide-sub', onClick: this.handleHideSub, className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]])
							},
							'Hide subscription info'
						)
					)
				) : React.createElement(
					'div',
					{
						className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'sub-controls'
					},
					React.createElement(
						'button',
						{ onClick: this.handleShowSub, className: _JSXStyle.dynamic([['1389108452', [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]]]) + ' ' + 'button outline'
						},
						'Subscribe to this calendar'
					)
				),
				React.createElement(
					_JSXStyle,
					{
						id: '1389108452',
						dynamic: [secondaryText, secondaryText, COLORS.PRIMARY, COLORS.PRIMARY, buttonHoverBackgroundColor, COLORS.PRIMARY, buttonHoverBackgroundColor]
					},
					['.subscription-component.__jsx-style-dynamic-selector{margin:2em;}', '.sub-controls.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-wrap:wrap;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:space-around;-webkit-justify-content:space-around;-ms-flex-pack:space-around;justify-content:space-around;-webkit-align-items:flex-end;-webkit-box-align:flex-end;-ms-flex-align:flex-end;align-items:flex-end;font-size:1.25em;}', '.copy-with-url.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;-webkit-align-items:stretch;-webkit-box-align:stretch;-ms-flex-align:stretch;align-items:stretch;}', '#sub-url.__jsx-style-dynamic-selector{display:block;-webkit-user-select:all;-moz-user-select:all;-ms-user-select:all;user-select:all;color:' + secondaryText + ';}', '#hide-sub.__jsx-style-dynamic-selector{font-size:0.85em;-webkit-text-decoration:none;text-decoration:none;color:' + secondaryText + ';}', '#hide-sub.__jsx-style-dynamic-selector:hover{-webkit-text-decoration:underline;text-decoration:underline;}', 'input.__jsx-style-dynamic-selector{font-size:1.5em;padding:0.5em;border:1px solid rgba($grey-color,0.45);}', '.button.__jsx-style-dynamic-selector{margin:0.5em;border-radius:5px;padding:0.5em 1em;cursor:pointer;-webkit-text-decoration:none;text-decoration:none;color:white;font-size:1.25em;line-height:1.4;border:2px solid ' + COLORS.PRIMARY + ';background:' + COLORS.PRIMARY + ';}', '.button.__jsx-style-dynamic-selector:hover{background:' + buttonHoverBackgroundColor + ';}', '.button.outline.__jsx-style-dynamic-selector{background:transparent;color:' + COLORS.PRIMARY + ';}', '.button.outline.__jsx-style-dynamic-selector:hover{color:white;background:' + buttonHoverBackgroundColor + ';}', '.text-center.__jsx-style-dynamic-selector{text-align:center;}', '@media print{.subscription-component.__jsx-style-dynamic-selector{display:none;}}']
				)
			);
		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate() {
			var _this2 = this;

			if (this.state.showSub) {
				this.clipboard = new Clipboard('#copy-button');
				this.clipboard.on('success', function () {
					_this2.setState({ copied: true }, function () {
						window.setTimeout(function () {
							_this2.setState({ copied: false });
						}, 2000);
					});
				});
			}
		}
	}, {
		key: 'handleShowSub',
		value: function handleShowSub(event) {
			event.preventDefault();
			this.setState({ showSub: true });
		}
	}, {
		key: 'handleHideSub',
		value: function handleHideSub(event) {
			event.preventDefault();
			this.setState({ showSub: false });
		}
	}, {
		key: 'toggleShowUrl',
		value: function toggleShowUrl() {
			this.setState(function (state) {
				return { showUrl: !state.showUrl };
			});
		}
	}, {
		key: 'handleCopyButtonMouseDown',
		value: function handleCopyButtonMouseDown() {
			var _this3 = this;

			this.copyButtonPressTimeout = window.setTimeout(function () {
				_this3.toggleShowUrl();
			}, 1000);
		}
	}, {
		key: 'handleCopyButtonMouseUp',
		value: function handleCopyButtonMouseUp() {
			if (this.copyButtonPressTimeout) window.clearTimeout(this.copyButtonPressTimeout);
		}
	}]);

	return Subscription;
}(Component);

export default Subscription;


Subscription.propTypes = {
	url: PropTypes.string
};